
local C = require("classic")
local M = require("menu")

function menu_item_exists(id)
   for k,v in ipairs(kts.MENU.items) do
      if v.id == id then
         return true
      end
   end
   return false
end

function add_menu_item_after(item_id, old_id)
   if menu_item_exists(old_id) then
      local pos
      for k,v in ipairs(kts.MENU.items) do
         if v.id == old_id then
            pos = k
            break
         end
      end
      table.insert(kts.MENU.items, pos+1, item_id) -- Add after the specified choice
   else
      table.insert(kts.MENU.items, item_id)  -- Add it at the end.
   end
end


function add_living_armors(num)
   local count_table = { }
   -- Initialize the table of living armor counts first
   for i=1, #living_armors do
      table.insert(count_table, 0)
   end
   -- Increase the counts of random types of living armors
   for i=1, num do
      local j = kts.RandomRange(1, #living_armor_chances)
      local k = living_armor_chances[j]
      count_table[k] = (count_table[k]) + 1
   end
   -- And then finally add the monsters to the dungeon table
   for i=1, #living_armors do
      C.add_initial_monsters(living_armors[i], count_table[i])
      C.add_monster_limit   (living_armors[i], count_table[i])
   end
end

-- Menu item for living armors

-- M.add_menu_item("spacer")

livarm_item = { 
   id = "living_armors",
   text = "Living Armors",
   choice_min = 0,
   choice_max = 100,
   features = function(S)
      local num_livarms = 0
      if S.living_armors > 0 then
         num_livarms = 2 * S.living_armors
         add_living_armors(num_livarms) 
      end
   end
}

add_menu_item_after(livarm_item, "bats")

--
